--- /tmp/backend.py.orig	2010-03-15 12:10:30.000000000 +0100
+++ /usr/lib/python2.6/site-packages/mock/backend.py	2010-03-15 14:16:38.000000000 +0100
@@ -85,14 +85,14 @@
             self.pluginConf[key]['cache_topdir'] = self.cache_topdir
             self.pluginConf[key]['cachedir'] = self.cachedir
             self.pluginConf[key]['root'] = self.sharedRootName
-
-        # mount/umount
-        self.umountCmds = ['umount -n %s' % self.makeChrootPath('proc'),
-                'umount -n %s' % self.makeChrootPath('sys')
-               ]
+        
+        # mount
         self.mountCmds = ['mount -n -t proc   mock_chroot_proc   %s' % self.makeChrootPath('proc'),
                 'mount -n -t sysfs  mock_chroot_sysfs  %s' % self.makeChrootPath('sys'),
                ]
+        # retain umountCmds for interfacing sake, but they're not required 
+        # anymore
+        self.umountCmds = []
 
         self.build_log_fmt_str = config['build_log_fmt_str']
         self.root_log_fmt_str = config['root_log_fmt_str']
@@ -340,13 +340,6 @@
 
         os.umask(prevMask)
 
-        # mount/umount
-        for devUnmtCmd in (
-                'umount -n %s' % self.makeChrootPath('/dev/pts'),
-                'umount -n %s' % self.makeChrootPath('/dev/shm') ):
-            if devUnmtCmd not in self.umountCmds:
-                self.umountCmds.append(devUnmtCmd)
-
         mountopt = 'gid=%d,mode=0620,ptmxmode=0666' % grp.getgrnam('tty').gr_gid
         if kver >= '2.6.29':
             mountopt += ',newinstance'
@@ -587,9 +580,19 @@
     decorate(traceLog())
     def _umountall(self):
         """umount all mounted chroot fs."""
-        for cmd in self.umountCmds:
-            self.root_log.debug(cmd)
-            mock.util.do(cmd, raiseExc=0, shell=True)
+        mountpoints = mock.util.do("cat /proc/mounts", raiseExc=0, shell=True, returnOutput=1)
+        # umount in reverse mount order to prevent nested mount issues that 
+        # may prevent clean unmount.
+        for mountline in reversed(mountpoints.split("\n")):
+            try:
+                mountpoint = mountline.split(" ")[1]
+                if self.makeChrootPath("/") in mountpoint:
+                    cmd = "umount -n %s" % mountpoint
+                    self.root_log.debug(cmd)
+                    mock.util.do(cmd, raiseExc=0, shell=True)
+            except:
+                # dont mind about wrong parsing, etc. just go on with the next
+                continue
 
     decorate(traceLog())
     def _yum(self, cmd, returnOutput=0):
